# https://github.com/ajstarks/giocanvas



LIB_REPO=						github.com/ajstarks
LIB_REPO_FSPATH=				$(GOPATH)/src/$(LIB_REPO)

CAN_LIB_NAME=					giocanvas
CAN_LIB=						$(LIB_REPO)/$(CAN_LIB_NAME)
CAN_LIB_FSPATH=					$(LIB_REPO_FSPATH)/$(CAN_LIB_NAME)
CAN_LIB_TAGNAME=NONE

this-print:
	@echo
	@echo LIB_REPO: 			$(LIB_REPO)
	@echo LIB_REPO_FSPATH: 		$(LIB_REPO_FSPATH)

	@echo
	@echo CAN_LIB_FSPATH: 		$(CAN_LIB_FSPATH)

this-git-clone:
	$(MAKE) git-clone-args LIB=$(CAN_LIB) LIB_FSPATH=$(CAN_LIB_FSPATH)
	
this-git-delete:
	rm -rf $(LIB_REPO_FSPATH)

this-vscode-add:
	# copy vscode debug json into project
	mkdir -p $(LIB_REPO_FSPATH)/.vscode
	cp ./launch.json $(LIB_REPO_FSPATH)/.vscode/.

	# copy make file in
	cp ./makefile $(LIB_REPO_FSPATH)/.

	# Now add the project as a workspace
	code --add $(LIB_REPO_FSPATH)

vscode-open:
	code $(LIB_REPO_FSPATH)

## BUILD

BIN_FSPATH=$(PWD)/bin
DATA_FSPATH=$(PWD)/data

dep:
	go get -u github.com/shurcooL/goexec

init: dep
	cd $(CAN_LIB_FSPATH) && go mod init
	cp wasm-*.sh $(CAN_LIB_FSPATH)/.
	cd $(CAN_LIB_FSPATH) && chmod +x *.sh 
init-clean:
	cd $(CAN_LIB_FSPATH) && rm wasm-*.sh
	cd $(CAN_LIB_FSPATH) && rm go.mod
	cd $(CAN_LIB_FSPATH) && rm go.sum


desk-all-build:
	# desk 
	cd $(CAN_LIB_FSPATH) && ./bc.sh

desk-all-run:
	# run all
	cd $(CAN_LIB_FSPATH) && ./rc.sh

wasm-all-build:
	# make www structure
	cd $(CAN_LIB_FSPATH) && ./wasm-build.sh

wasm-all-clean:
	cd $(CAN_LIB_FSPATH) && ./wasm-build-clean.sh

wasm-all-run:
	cd $(CAN_LIB_FSPATH) && ./wasm-build-run.sh
	
wasm-play-run:
	cd $(CAN_LIB_FSPATH)/www/play && goexec -quiet 'http.ListenAndServe(":8080", http.FileServer(http.Dir("www")))'

